// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/error_log
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/spaces -i Spaces -t ../../../assets/templates/middleware/error_log -o error_logging_middleware.go -l ""

import (
	"context"

	"git.perx.ru/perxis/perxis-go/pkg/options"
	"git.perx.ru/perxis/perxis-go/pkg/spaces"
	"go.uber.org/zap"
)

// errorLoggingMiddleware implements spaces.Spaces that is instrumented with logging
type errorLoggingMiddleware struct {
	logger *zap.Logger
	next   spaces.Spaces
}

// ErrorLoggingMiddleware instruments an implementation of the spaces.Spaces with simple logging
func ErrorLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next spaces.Spaces) spaces.Spaces {
		return &errorLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *errorLoggingMiddleware) AbortTransfer(ctx context.Context, id string) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.AbortTransfer(ctx, id)
}

func (m *errorLoggingMiddleware) Create(ctx context.Context, space *spaces.Space) (created *spaces.Space, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Create(ctx, space)
}

func (m *errorLoggingMiddleware) Delete(ctx context.Context, id string) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Delete(ctx, id)
}

func (m *errorLoggingMiddleware) Find(ctx context.Context, filter *spaces.Filter, fo *options.FindOptions) (spaces []*spaces.Space, total int, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Find(ctx, filter, fo)
}

func (m *errorLoggingMiddleware) Get(ctx context.Context, id string) (space *spaces.Space, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Get(ctx, id)
}

func (m *errorLoggingMiddleware) List(ctx context.Context, orgId string) (spaces []*spaces.Space, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.List(ctx, orgId)
}

func (m *errorLoggingMiddleware) ListTransfers(ctx context.Context, orgID string) (spaces []*spaces.Space, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.ListTransfers(ctx, orgID)
}

func (m *errorLoggingMiddleware) Move(ctx context.Context, id string, orgID string) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Move(ctx, id, orgID)
}

func (m *errorLoggingMiddleware) SetState(ctx context.Context, id string, state *spaces.StateInfo) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.SetState(ctx, id, state)
}

func (m *errorLoggingMiddleware) Transfer(ctx context.Context, id string, transferToOrg string) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Transfer(ctx, id, transferToOrg)
}

func (m *errorLoggingMiddleware) Update(ctx context.Context, space *spaces.Space) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Update(ctx, space)
}

func (m *errorLoggingMiddleware) UpdateConfig(ctx context.Context, id string, config *spaces.Config) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.UpdateConfig(ctx, id, config)
}
